#include <stdio.h>
#include <string.h>
#include <stdlib.h>
int main()
{
   int n,q;
   scanf("%d%d",&n,&q);
   int d[n];
   int p[n];
   int sdk=0;
   for(int i=0;i<n;i++)
   {
       scanf("%d%d",&d[i],&p[i]);
       sdk+=d[i];
   }
   int b[q];
   for(int i=0;i<q;i++)
   {
        scanf("%d",&b[i]);
   }
   for(int i=0;i<q;i++)
   {
       if(b[i]>sdk)
       {
           printf("-1\n");
       }
       else
       {
           int ans=0;
           int t=0;
           while(b[i]>=0)
           {
                b[i]-=d[t++];
                ans++;
           }
           printf("%d\n",ans);
       }
   }

}